set -euxo pipefail

PALONLP_DIR=~/palonlp
ENV_DOCKER_FILE=~/.env.docker
ENV_FRONTEND_FILE=~/.env.frontend
CREDS_FILE=~/dbt-user-creds.json

source ~/.env.gitlab
source ~/.env.reddit

if test -d ${PALONLP_DIR}; then
  cd ${PALONLP_DIR}
  git pull
else
  git clone ${CI_PROJECT_URL}
  cd ${PALONLP_DIR}
  mv -f ${REDDIT_FCP_YML} dags/jobs/configs/reddit_fcp.yml
  mv -f ${REDDIT_ELT_YML} dags/jobs/configs/reddit_elt.yml
  mv -f ${SUBREDDIT_TRAIN_YML} dags/jobs/configs/train_subreddit.yml
fi

#copy env file generated by Gitlab
if test -f ${ENV_DOCKER_FILE}; then
  mv -f ${ENV_DOCKER_FILE} deploy/.env
fi
if test -f ${CREDS_FILE}; then
  cp ${CREDS_FILE} streamlit_apps/dbt-user-creds.json
  mv -f ${CREDS_FILE} dags/dbt-user-creds.json
fi
if test -f ${ENV_FRONTEND_FILE}; then
  mv -f ${ENV_FRONTEND_FILE} frontend/.env.production
fi

cd frontend
npm install
npm run build

cd ../deploy
pwd

echo "--> Build and start all services <--"
docker-compose up --build -d
